diff --git a/libs/zgpu/libs/imgui/imgui_impl_glfw.cpp b/libs/zgpu/libs/imgui/imgui_impl_glfw.cpp
index 6fde3a6a1..5fce01a4e 100644
--- a/libs/zgpu/libs/imgui/imgui_impl_glfw.cpp
+++ b/libs/zgpu/libs/imgui/imgui_impl_glfw.cpp
@@ -79,6 +79,8 @@
 #define GLFW_HAS_GAMEPAD_API          (GLFW_VERSION_MAJOR * 1000 + GLFW_VERSION_MINOR * 100 >= 3300) // 3.3+ glfwGetGamepadState() new api
 #define GLFW_HAS_GET_KEY_NAME         (GLFW_VERSION_MAJOR * 1000 + GLFW_VERSION_MINOR * 100 >= 3200) // 3.2+ glfwGetKeyName()
 
+#include <math.h>
+
 // GLFW data
 enum GlfwClientApi
 {
@@ -97,6 +99,8 @@ struct ImGui_ImplGlfw_Data
     ImVec2                  LastValidMousePos;
     bool                    InstalledCallbacks;
 
+    ImVec2                  DpiScale; // mziulek
+
     // Chain GLFW callbacks: our callbacks will call the user's previously installed callbacks, if any.
     GLFWwindowfocusfun      PrevUserCallbackWindowFocus;
     GLFWcursorposfun        PrevUserCallbackCursorPos;
@@ -355,11 +359,11 @@ void ImGui_ImplGlfw_CursorPosCallback(GLFWwindow* window, double x, double y)
 {
     ImGui_ImplGlfw_Data* bd = ImGui_ImplGlfw_GetBackendData();
     if (bd->PrevUserCallbackCursorPos != NULL && window == bd->Window)
-        bd->PrevUserCallbackCursorPos(window, x, y);
+        bd->PrevUserCallbackCursorPos(window, x * bd->DpiScale.x, y * bd->DpiScale.y);
 
     ImGuiIO& io = ImGui::GetIO();
-    io.AddMousePosEvent((float)x, (float)y);
-    bd->LastValidMousePos = ImVec2((float)x, (float)y);
+    io.AddMousePosEvent((float)x * bd->DpiScale.x, (float)y * bd->DpiScale.y);
+    bd->LastValidMousePos = ImVec2((float)x * bd->DpiScale.x, (float)y * bd->DpiScale.y);
 }
 
 // Workaround: X11 seems to send spurious Leave/Enter events which would make us lose our position,
@@ -455,6 +459,7 @@ static bool ImGui_ImplGlfw_Init(GLFWwindow* window, bool install_callbacks, Glfw
 
     bd->Window = window;
     bd->Time = 0.0;
+    bd->DpiScale = ImVec2{ 1.0, 1.0 };
 
     io.SetClipboardTextFn = ImGui_ImplGlfw_SetClipboardText;
     io.GetClipboardTextFn = ImGui_ImplGlfw_GetClipboardText;
@@ -549,8 +554,8 @@ static void ImGui_ImplGlfw_UpdateMouseData()
         {
             double mouse_x, mouse_y;
             glfwGetCursorPos(bd->Window, &mouse_x, &mouse_y);
-            io.AddMousePosEvent((float)mouse_x, (float)mouse_y);
-            bd->LastValidMousePos = ImVec2((float)mouse_x, (float)mouse_y);
+            io.AddMousePosEvent((float)mouse_x * bd->DpiScale.x, (float)mouse_y * bd->DpiScale.y);
+            bd->LastValidMousePos = ImVec2((float)mouse_x * bd->DpiScale.x, (float)mouse_y * bd->DpiScale.y);
         }
     }
 }
@@ -645,6 +650,9 @@ void ImGui_ImplGlfw_NewFrame()
     if (w > 0 && h > 0)
         io.DisplayFramebufferScale = ImVec2((float)display_w / (float)w, (float)display_h / (float)h);
 
+    bd->DpiScale.x = ceil(io.DisplayFramebufferScale.x);
+    bd->DpiScale.y = ceil(io.DisplayFramebufferScale.y);
+
     // Setup time step
     double current_time = glfwGetTime();
     io.DeltaTime = bd->Time > 0.0 ? (float)(current_time - bd->Time) : (float)(1.0f / 60.0f);
diff --git a/libs/zgpu/src/zgpu.zig b/libs/zgpu/src/zgpu.zig
index b1d43f087..68468e315 100644
--- a/libs/zgpu/src/zgpu.zig
+++ b/libs/zgpu/src/zgpu.zig
@@ -965,8 +965,8 @@ pub const gui = struct {
     }
 
     pub fn newFrame(fb_width: u32, fb_height: u32) void {
-        ImGui_ImplGlfw_NewFrame();
         ImGui_ImplWGPU_NewFrame();
+        ImGui_ImplGlfw_NewFrame();
         {
             const io = cimgui.igGetIO().?;
             io.*.DisplaySize = .{
diff --git a/samples/procedural_mesh_wgpu/src/procedural_mesh_wgpu.zig b/samples/procedural_mesh_wgpu/src/procedural_mesh_wgpu.zig
index ded1032cb..f96d20920 100644
--- a/samples/procedural_mesh_wgpu/src/procedural_mesh_wgpu.zig
+++ b/samples/procedural_mesh_wgpu/src/procedural_mesh_wgpu.zig
@@ -408,8 +408,7 @@ fn init(allocator: std.mem.Allocator, window: glfw.Window) !DemoState {
     gctx.queue.writeBuffer(gctx.lookupResource(index_buffer).?, 0, u16, meshes_indices.items);
 
     // Create a depth texture and it's 'view'.
-    const fb_size = try window.getFramebufferSize();
-    const depth = createDepthTexture(gctx, fb_size.width, fb_size.height);
+    const depth = createDepthTexture(gctx);
 
     return DemoState{
         .gctx = gctx,
@@ -434,19 +433,17 @@ fn deinit(allocator: std.mem.Allocator, demo: *DemoState) void {
 fn update(demo: *DemoState) void {
     zgpu.gui.newFrame(demo.gctx.swapchain_descriptor.width, demo.gctx.swapchain_descriptor.height);
 
-    const window = demo.gctx.window;
-
     const main_viewport = c.igGetMainViewport().?.*;
     c.igSetNextWindowPos(
         .{ .x = main_viewport.WorkPos.x + 20.0, .y = main_viewport.WorkPos.y + 20.0 },
-        c.ImGuiCond_FirstUseEver,
+        c.ImGuiCond_Always,
         .{ .x = 0.0, .y = 0.0 },
     );
-    c.igSetNextWindowSize(.{ .x = 600.0, .y = -1 }, c.ImGuiCond_FirstUseEver);
+    c.igSetNextWindowSize(.{ .x = 600.0, .y = -1 }, c.ImGuiCond_Always);
     _ = c.igBegin(
         "Demo Settings",
         null,
-        c.ImGuiWindowFlags_NoMove | c.ImGuiWindowFlags_NoResize | c.ImGuiWindowFlags_NoSavedSettings,
+        c.ImGuiWindowFlags_NoMove | c.ImGuiWindowFlags_NoResize,
     );
 
     c.igBulletText("", "");
@@ -463,6 +460,8 @@ fn update(demo: *DemoState) void {
 
     c.igEnd();
 
+    const window = demo.gctx.window;
+
     // Handle camera rotation with mouse.
     {
         const cursor = window.getCursorPos() catch unreachable;
@@ -627,24 +626,24 @@ fn draw(demo: *DemoState) void {
         gctx.destroyResource(demo.depth_texture);
 
         // Create a new depth texture to match the new window size.
-        const depth = createDepthTexture(
-            gctx,
-            gctx.swapchain_descriptor.width,
-            gctx.swapchain_descriptor.height,
-        );
+        const depth = createDepthTexture(gctx);
         demo.depth_texture = depth.texture;
         demo.depth_texture_view = depth.view;
     }
 }
 
-fn createDepthTexture(gctx: *zgpu.GraphicsContext, width: u32, height: u32) struct {
+fn createDepthTexture(gctx: *zgpu.GraphicsContext) struct {
     texture: zgpu.TextureHandle,
     view: zgpu.TextureViewHandle,
 } {
     const texture = gctx.createTexture(.{
         .usage = .{ .render_attachment = true },
         .dimension = .dimension_2d,
-        .size = .{ .width = width, .height = height, .depth_or_array_layers = 1 },
+        .size = .{
+            .width = gctx.swapchain_descriptor.width,
+            .height = gctx.swapchain_descriptor.height,
+            .depth_or_array_layers = 1,
+        },
         .format = .depth32_float,
         .mip_level_count = 1,
         .sample_count = 1,
diff --git a/samples/triangle_wgpu/src/triangle_wgpu.zig b/samples/triangle_wgpu/src/triangle_wgpu.zig
index 3174b5c17..479723adc 100644
--- a/samples/triangle_wgpu/src/triangle_wgpu.zig
+++ b/samples/triangle_wgpu/src/triangle_wgpu.zig
@@ -145,8 +145,7 @@ fn init(allocator: std.mem.Allocator, window: glfw.Window) !DemoState {
     gctx.queue.writeBuffer(gctx.lookupResource(index_buffer).?, 0, u32, index_data[0..]);
 
     // Create a depth texture and it's 'view'.
-    const fb_size = try window.getFramebufferSize();
-    const depth = createDepthTexture(gctx, fb_size.width, fb_size.height);
+    const depth = createDepthTexture(gctx);
 
     return DemoState{
         .gctx = gctx,
@@ -280,24 +279,24 @@ fn draw(demo: *DemoState) void {
         gctx.destroyResource(demo.depth_texture);
 
         // Create a new depth texture to match the new window size.
-        const depth = createDepthTexture(
-            gctx,
-            gctx.swapchain_descriptor.width,
-            gctx.swapchain_descriptor.height,
-        );
+        const depth = createDepthTexture(gctx);
         demo.depth_texture = depth.texture;
         demo.depth_texture_view = depth.view;
     }
 }
 
-fn createDepthTexture(gctx: *zgpu.GraphicsContext, width: u32, height: u32) struct {
+fn createDepthTexture(gctx: *zgpu.GraphicsContext) struct {
     texture: zgpu.TextureHandle,
     view: zgpu.TextureViewHandle,
 } {
     const texture = gctx.createTexture(.{
         .usage = .{ .render_attachment = true },
         .dimension = .dimension_2d,
-        .size = .{ .width = width, .height = height, .depth_or_array_layers = 1 },
+        .size = .{
+            .width = gctx.swapchain_descriptor.width,
+            .height = gctx.swapchain_descriptor.height,
+            .depth_or_array_layers = 1,
+        },
         .format = .depth32_float,
         .mip_level_count = 1,
         .sample_count = 1,
